<?php
// $Id: textsize.admin.inc,v 1.1.2.6 2009/10/02 12:43:07 christianzwahlen Exp $

/**
 * @file
 * Provides the Text Size administrative interface.
 */

/**
 * Implementation of hook_help().
 */
function textsize_help($path, $arg) {
  $path_textsize =  base_path() . drupal_get_path('module', 'textsize');
  $textsize_increment = variable_get('textsize_increment', 10);
  $link_wcag = l('Web Content Accessibility Guidelines', 'http://www.w3.org/TR/WCAG/', array('attributes' => array('title' => 'Web Content Accessibility Guidelines')));
  $link_bitv= l('bundesrecht.juris.de', 'http://bundesrecht.juris.de/bitv/anlage_8.html', array('attributes' => array('title' => 'bundesrecht.juris.de')));
  $link_ff = l('www.mozilla.com/en-US/firefox/', 'http://www.mozilla.com/en-US/firefox', array('attributes' => array('title' => 'Mozilla Firefox')));
  $link_ts = l(t('Text Size') .' '. t('Home page'), 'http://zwahlendesign.ch/en/textsize', array('attributes' => array('title' => t('Text Size') .' '. t('Home page'))));
  $abbr_php = '<abbr lang="en" xml:lang="en" title="PHP: Hypertext Preprocessor">PHP</abbr>';
  $abbr_mysql = '<abbr title="MySQL">MySQL</abbr>';
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $abbr_png = '<abbr lang="en" xml:lang="en" title="Portable Network Graphics">PNG</abbr>';
  $abbr_gif = '<abbr lang="en" xml:lang="en" title="Graphic Interchange Format">GIF</abbr>';
  $abbr_svg = '<abbr lang="en" xml:lang="en" title="Scalable Vector Graphics">SVG</abbr>';
  $abbr_id = '<abbr lang="en" xml:lang="en" title="Identification">ID</abbr>';
  switch ($path) {
    case 'admin/help#textsize':
      $output = '<p><img src="'. $path_textsize .'/images/textsize_list.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right" />'. t('This module display a adjustable text size changer or a zoom function on the page for a better web accessibility.') .'</p>'."\n";
      $output .= '<p>'. t('The zoom function is comparable to the text zoom function in Firefox 3, but this module resize also variable media objects, variable pixel images and vector images.')  .'</p>'."\n";
      $output .= '<h3>'. t('Advantages compared with browser zoom') .'</h3>'."\n";
      $output .= '<ol>'."\n";
      $output .= '<li><strong>'. t('Adjustable (increases/decreases step, minimum, maximum, standard and variable or three fixed values).') .'</strong></li>'."\n";
      $output .= '<li><strong>'. t('Resize region definable (for example a div with a !abbr_id "content": &lt;div id="content"&gt;).', array('!abbr_id' =>  $abbr_xhtml)) .'</strong></li>'."\n";
      $output .= '<li><strong>'. t('Browser independent.') .'</strong></li>'."\n";
      $output .= '<li>'. t('One click function. No tutorial required.') .'</li>'."\n";
      $output .= '<li>'. t('Same handling in any browser (shortcuts).') .'</li>'."\n";
      $output .= '<li>'. t('Resize text, variable images and media objects (media objects or pixel images with "em" or "%" and !abbr_svg images)', array('!abbr_svg' =>  $abbr_svg)) .'</li>'."\n";
      $output .= '<li>'. t('Select menu availabe.') .'</li>'."\n";
      $output .= '<li>'. t('Display current text size (zoom size).') .'</li>'."\n";
      $output .= '</ol>'."\n";
      $output .= '<h3>'. t('Requirements') .'</h3>'."\n";
      $output .= '<ol>'."\n";
      $output .= '<li>'. t('Drupal Module:') .' '. l(t('jQuery plugins'), 'http://drupal.org/project/jquery_plugin') .'.</li>'."\n";
      $output .= '<li>'. t('Browser Internet Explorer: Theme or a theme region with font sitze "em", "%" or no sitze.') .'</li>'."\n";
      $output .= '</ol>'."\n";
      $output .= '<h3>'. t('Features') .'</h3>'."\n";
      $output .= '<p>'. t('The module is a !abbr_php module and use JavaScript and Cookies if supported,  but no !abbr_mysql. Cookies are required, for saving the text size durable and in old browsers.', array('!abbr_php' =>  $abbr_php, '!abbr_mysql' =>  $abbr_mysql)) .'</p>'."\n";
      $output .= '<ul>'."\n";
      $output .= '<li>'. t('!abbr_wcag and !abbr_bitv conform. More Information on: !link_wcag and !link_bitv.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv, '!link_wcag' => $link_wcag, '!link_bitv' => $link_bitv)) .' '. t('Keep the conditions:') .' '."\n";
      $output .= '  <ol>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 1.1: Alt text in the images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 3.1: Standard links with text and not images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 6.3: No JavaScript rquired.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 11.1: Open and standard code.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 13.6: Links in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  </ol>'."\n";
      $output .= '</li>'."\n";
      $output .= '<li>'. t('No JavaScript required. jQuery suppport.') .'</li>'."\n";
      $output .= '<li>'. t('No !abbr_css required.', array('!abbr_css' => $abbr_css)) .'</li>'."\n";
      $output .= '<li>'. t('Minimum and maximum text size.') .'</li>'."\n";
      $output .= '<li>'. t('Caching mode: "Normal" and "Aggressive" compatible.') .'</li>'."\n";
      $output .= '  <li>'. t('Block type') ."\n";
      $output .= '    <ol>'."\n";
      $output .= '    <li><a href="#ts_text" title="'. t('Block') .': '. t('Text links') .'.">'. t('Text links') .'</a> [1].</li>'."\n";
      $output .= '    <li><a href="#ts_images" title="'. t('Block') .': '. t('Image links') .'.">'. t('Image links') .'</a> [2].</li>'."\n";
      $output .= '    <li><a href="#ts_select" title="'. t('Block') .': '. t('Select menu') .'.">'. t('Select menu') .'.</a></li>'."\n";
      $output .= '    </ol>'."\n";
      $output .= '  </li>'."\n";
      $output .= '<li>'. t('Uniform markin of menu, based on the open source browser Firefox 2.0 (!link_ff).', array('!link_ff' => $link_ff)) .'</li>'."\n";
      $output .= '<li>'. t('Themable. See: textsize-text.tpl.php, textsize-image.tpl.php or textsize-form.tpl.php') .'</li>'."\n";
      $output .= '<li>'. t('Tested themes: Bluemarine, Garland.') .'</li>'."\n";
      $output .= '</ul>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Global settings') .'</h3>'."\n";
      $output .= '<h4>'. t('Block title') .'</h4>'."\n";
      $output .= '<p>'. t('Select the block title.') .' '. t('Text Size') .' '. t('or') .' '. t('Zoom') .'.</p>'."\n";
      $output .= '<h4>'. t('Block type') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '  <dt id="ts_text">'. t('Text links') .'</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_list.png" alt="'. t('Screenshot of block:') .' '. t('Text links') .'." class="float_right" />'. t('Images are showed with !abbr_css.', array('!abbr_css' => $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span></dd>'."\n";
      $output .= '  <dt id="ts_images">'. t('Image links') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_img.png" alt="'. t('Screenshot of block:') .' '. t('Image links') .'." class=""/><br />'. t('No Link text, only images in the !abbr_xhtml source code with standard 0 pixel margin.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! If JavaScript is not activated: No image change action if the cursor move over the images!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></dd>'."\n";
      $output .= '  <dt id="ts_select">'. t('Select menu') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_textsize .'/images/textsize_select.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right"/></dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h4>'. t('Links type') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '  <dt>'. t('Variable links') .'</dt>'."\n";
      $output .= '  <dd>'. t('Bounded by the minimum and maximum text size.') .'</dd>'."\n";
      $output .= '  <dt>'. t('Fixed links') .'</dt>'."\n";
      $output .= '  <dd>'. t('Fixed links shows only 3 options for changing the text size (Increase, decrease and normal).') .'</dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h3>'. t('Advanced settings') .'</h3>'."\n";
      $output .= '<p>'. t('!abbr_xhtml element', array('!abbr_xhtml' =>  $abbr_xhtml)) .': '. t('Select the !abbr_xhtml element for the resize process.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</p>'."\n";
      $output .= '<p>'. t('!abbr_xhtml element !abbr_id/class', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)) .': '. t('Define a !abbr_id ("#myid") or a class (".myclass") for the !abbr_xhtml element. Standard is the textfield empty for the body element.', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)) .'</p>'."\n";
      $output .= '<p>'. t('Increases/decreases step') .': '. t('Percentage by which each click increases/decreases the text size.') .' '. t('The default increases/decreases step is 5&#037;.') .'</p>'."\n";
      $output .= '<p>'. t('Text Size Normal') .': '. t('The default normal text size is 75&#037;.') .'</p>'."\n";
      $output .= '<p>'. t('Display text size normal as 100&#037;') .': '. t("Default checked for: Yes.") .'</p>'."\n";
      $output .= '<p>'. t('Minimum Text Size') .': '. t("The minimum default text size is 50&#037;.") .'</p>'."\n";
      $output .= '<p>'. t('Maximum Text Size') .': '. t("The maximum default text size is 150&#037;.") .'</p>'."\n";
      $output .= '<p>'.  t('JavaScript Support') .': '. t('Yes') .' '. t('or') .' '. t('No (for caching mode).') .' '. t('Support JavaScript (jQuery) or only !abbr_php for caching mode: "Normal" and "Aggressive" and anonymous users.', array('!abbr_php' =>  $abbr_php)) .'</p>'."\n";
      $output .= '<h3>'. t('Theme settings') .'</h3>'."\n";
      $output .= '<p>'. t('List display') .': '. t('Set the display of the list.') .' '. t('Style') .': '. t('Normal') .'/'. t('Inline.') .'</p>'."\n";
      $output .= '<p>'. t('Text display') .': '. t('By hide text in the links, it shows only the images.') .' '. t('Hide text in the links') .': <span class="warning">'. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span></p>'."\n";
      $output .= '<p>'. t('Current text size display') .': '. t('By hide current text size, it shows no text.') .'</p>'."\n";
      $output .= '<p>'. t('Overwrite text size in templates') .': '. t('Overwrite the font-size value of the current theme (with "!important").') .' '. t('Overwrite templates') .' '. t('or') .' '. t('No (less code)') .': <span class="warning">'. t('Warning: Delete in your theme the !abbr_css style: "!abbr_xhtml element/!abbr_id/class {font-size: ...;}". For example:', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_css' => $abbr_css, '!abbr_id' =>  $abbr_id)) .'"<del>body {font-size: 12px; }</del>".</span></p>'."\n";
      $output .= '<h4>'. t('Overriding themable output') .'</h4>'."\n";
      $output .= '<p>'. t('Copy the files files textsize-text.tpl.php, textsize-image.tpl.php and textsize-form.tpl.php, textsize.css and the directory "images" in your theme and edit it.') .'</p>'."\n";
      $output .= '<p>'. t('You can also download edited templates from the developers website: !link_ts.', array('!link_ts' => $link_ts)) .'</p>'."\n";
      $output .= '<h5>'. t('Example:') .' "'. t('Image links, not in a list') .'"</h5>'."\n";
      $output .= '<p><img src="'. $path_textsize .'/images/textsize_img2.png" alt="'. t('Screenshot of block:') .' '. t('Image links, not in a list') .'." class="float_right"/>'. t('Change the following elements:') .'<br /><del>&#060;ul&#062;/&#060;/ul&#062;</del> '. t('to') .': <ins>&#060;p&#062;/&#060;/p&#062;</ins><br /> <del>&#060;li&#062;&#060;/li&#062;</del> '. t('to') .': <ins>&#060;span class="display_hidden"&#062;&#160;&#124;&#160;&#060;/span&#062;</ins>.<br /><span class="info">'. t('!abbr_wcag/!abbr_bitv 10.5: Adjacent hyperlinks have to be separated by printable characters surrounded by spaces.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span><br /><span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 13.6! Links are not in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></p>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Important informations') .'</h3>'."\n";
      $output .= '<p class="warning">'. t('Warning: For Internet Explorer: Your theme have to use font sitze with "em" or "%", not pixel or points!') .'</p>'."\n";
      $output .= '<p>'. t('If you are using a theme with "font-size 0.9em" in the CSS (like the garland theme), set the text size normal to 90% or delete the "font-size" and "line-height" values for the body in your theme.') .'</p>'."\n";
      $output .= '<h4>'. t('Solutions for static themes') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '<dt>'. t('Define theme regions for the resize process') .'</dt>'."\n";
      $output .= '<dd>'. t('Example: Select the !abbr_xhtml element "div" and define a !abbr_id like "#content".', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_xhtml)) .'</dd>'."\n";
      $output .= '<dt>'. t('Edit themes') .'</dt>'."\n";
      $output .= '<dd>'. t('Example Garland theme: Open the file "themes/garland/style.css" and edit the code on line 15 for the body element. Delete the code:') ."\n";
      $output .= ' <code><del>font: 12px/170% Verdana, sans-serif; line-height:1.5;</del></code>, '."\n";
      $output .=  t('Add the following code:') ."\n";
      $output .= ' <code><ins>font-family: Verdana, sans-serif;</ins></code></dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h3>'. t('Source') .'</h3>'."\n";
      $output .= '<p>'. t('The !abbr_png and !abbr_gif images are in the directory "/textsize/images/" and the source file in "/textsize/images/source/".', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      $output .= '<p>[1] '. t('No images in the code (!abbr_css generated), only one link text (for example "Increase").', array('!abbr_css' => $abbr_css)) .'</p>'."\n";
      $output .= '<p>[2] '. t('!abbr_png images for new browsers and !abbr_gif images for old browsers (Internet Explorer 6).', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      return $output;
    break;
  }
}

/**
 * Builds and returns the textsize settings form.
 *
 * @ingroup forms
 * @see textsize_admin_settings_validate()
 */
function textsize_admin_settings() {
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_php = '<abbr lang="en" xml:lang="en" title="PHP: Hypertext Preprocessor">PHP</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $abbr_id = '<abbr lang="en" xml:lang="en" title="Identification">ID</abbr>';
  $form['textsize'] = array(
    '#type' => 'fieldset',
    '#title' => t('Global settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['textsize']['textsize_block_title'] = array(
    '#type' => 'radios',
    '#title' => t('Block title'),
    '#options' => array(
      'text_size' => t('Text Size'),
      'zoom' => t('Zoom'),
    ),
    '#default_value' => variable_get('textsize_block_title', 'text_size'),
    '#description' => t('Select the block title.'),
  );
  $form['textsize']['textsize_block_type'] = array(
    '#type' => 'radios',
    '#title' => t('Block type'),
    '#options' => array(
      'text' => t('Text links') .' [1]',
      'image' => t('Image links') .' [2]',
      'select' => t('Select menu'),
    ),
    '#default_value' => variable_get('textsize_block_type', 'text'),
    '#description' => t('Select the type of block.') .'&#160;<br />[1] '. t('Images are showed with !abbr_css.', array('!abbr_css' =>  $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span><br />[2] '. t('Images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! No hover action if JavaScript is not activated!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span>',
  );
  $form['textsize']['textsize_link_type'] = array(
    '#type' => 'radios',
    '#title' => t('Links type'),
    '#options' => array(
      'variable' => t('Variable links'),
      'fix' => t('Fixed links') .' [4]',
    ),
    '#default_value' => variable_get('textsize_link_type', 'variable'),
    '#description' => t('Select the type of links.') .'<br />[4] '. t('Fixed links shows only 3 options for changing the text size (Increase, decrease and normal).'),
  );
  $form['textsize_adv'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['textsize_adv']['textsize_element'] = array(
    '#type' => 'select',
    '#title' => t('!abbr_xhtml element', array('!abbr_xhtml' =>  $abbr_xhtml)),
    '#options' => array(
      'body' => 'body',
      'div' => 'div',
      'p' => 'p',
      'span' => 'span',
      'table' => 'table',
      'tr' => 'tr',
      'th' => 'th',
      'td' => 'td',
    ),
    '#default_value' => variable_get('textsize_element', 'body'),
    '#description' => t('Select the !abbr_xhtml element for the resize process. Standard is "body" for the whole page.', array('!abbr_xhtml' =>  $abbr_xhtml)),
  );
  $form['textsize_adv']['textsize_element_class'] = array(
    '#type' => 'textfield',
    '#title' => t('!abbr_xhtml element !abbr_id/class', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)),
    '#default_value' => variable_get('textsize_element_class', ''),
    '#description' => t('Define a !abbr_id ("#myid") or a class (".myclass") for the !abbr_xhtml element. Standard is the textfield empty for the body element.', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)),
  );
  $form['textsize_adv']['textsize_increment'] = array(
    '#type' => 'textfield',
    '#title' => t('Increases/decreases step'),
    '#default_value' => variable_get('textsize_increment', 5),
    '#size' => 2,
    '#maxlength' => 2,
    '#field_suffix' => '&#037;',
    '#required' => TRUE,
    '#description' => t("Percentage by which each click increases/decreases the text size.") .' '. t("The default increases/decreases step is 5&#037;.")
  );
  $form['textsize_adv']['textsize_normal'] = array(
    '#type' => 'textfield',
    '#title' => t('Text Size Normal'),
    '#default_value' => variable_get('textsize_normal', 75),
    '#size' => 3,
    '#maxlength' => 3,
    '#field_suffix' => '&#037;',
    '#required' => TRUE,
    '#description' => t("The default normal text size is 75&#037;."),
  );
  $form['textsize_adv']['textsize_display'] = array(
    '#type' => 'checkbox',
    '#title' => t('Display text size normal as 100&#037;.'),
    '#default_value' => variable_get('textsize_display', 1),
    '#description' => t("Default checked for: Yes."),
  );
  $form['textsize_adv']['textsize_minimum'] = array(
    '#type' => 'textfield',
    '#title' => t('Minimum Text Size'),
    '#default_value' => variable_get('textsize_minimum', 50),
    '#size' => 3,
    '#maxlength' => 3,
    '#field_suffix' => '&#037;',
    '#required' => TRUE,
    '#description' => t("The minimum default text size is 50&#037;."),
  );
  $form['textsize_adv']['textsize_maximum'] = array(
    '#type' => 'textfield',
    '#title' => t('Maximum Text Size'),
    '#default_value' => variable_get('textsize_maximum', 150),
    '#size' => 3,
    '#maxlength' => 3,
    '#field_suffix' => '&#037;',
    '#required' => TRUE,
    '#description' => t("The maximum default text size is 150&#037;."),
  );
  $form['textsize_adv']['textsize_javascript'] = array(
    '#type' => 'radios',
    '#title' => t('Support JavaScript'),
    '#options' => array(
      'js' => t('Yes'),
      'js_no' => t('No (for caching mode).'),
    ),
    '#default_value' => variable_get('textsize_javascript', 'js'),
    '#description' => t('Support JavaScript (jQuery) or only !abbr_php for caching mode: "Normal" and "Aggressive" and anonymous users.', array('!abbr_php' =>  $abbr_php)),
  );
  $form['textsize_theme'] = array(
    '#type' => 'fieldset',
    '#title' => t('Theme settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['textsize_theme']['textsize_list_inline'] = array(
    '#type' => 'radios',
    '#title' => t('List display'),
    '#options' => array(
      'list' => t('Normal'),
      'inline' => t('Inline'),
    ),
    '#default_value' => variable_get('textsize_list_inline', 'list'),
    '#description' => t('Set the display of the list.'),
  );
  $form['textsize_theme']['textsize_display_links'] = array(
    '#type' => 'radios',
    '#title' => t('Text display'),
    '#options' => array(
      'display' => t('Show text in the links'),
      'display_hidden' => t('Hide text in the links') .' [5]',
    ),
    '#default_value' => variable_get('textsize_display_links', 'display'), // default to show text links.
    '#description' => t('By hide text in the links, it shows only the images.') .' <br/> <span class="warning">[5] '. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span>',
  );
  $form['textsize_theme']['textsize_display_current_textsize'] = array(
    '#type' => 'radios',
    '#title' => t('Current text size display'),
    '#options' => array(
      'display' => t('Show current text size'),
      'display_hidden' => t('Hide current text size'),
    ),
    '#default_value' => variable_get('textsize_display_current_textsize', 'display'), // default to show current text size
    '#description' => t('By hide current text size, it shows no text.'),
  );
  $form['textsize_theme']['textsize_important'] = array(
    '#type' => 'radios',
    '#title' => t('Overwrite text size in templates'),
    '#options' => array(
      '!important;' => t('Overwrite templates'),
      ';' => t('No (less code)') .' [6]',
    ),
    '#default_value' => variable_get('textsize_important', "!important;"),
    '#description' => t('Overwrite the font-size value of the current theme (with "!important"). Note: The !abbr_xhtml element for the resize process can not have the value "!important" in the !abbr_css style "font-size".', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_css' => $abbr_css)) .'<br/> <span class="warning">[6] '. t('Warning: Delete in your theme the !abbr_css style: "!abbr_xhtml element/!abbr_id/class {font-size: ...;}". For example:', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_css' => $abbr_css, '!abbr_id' =>  $abbr_id)) .' "<del>body {font-size: 12px; }</del>".</span>',
  );
  return system_settings_form($form);
}

/**
 * Validate the textsize settings form.
 *
 * @see textsize_admin_settings()
 */
function textsize_admin_settings_validate($form, &$form_state) {
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_id = '<abbr lang="en" xml:lang="en" title="Identification">ID</abbr>';
  $ts_in = $form_state['values']['textsize_increment'];
  $ts_no = $form_state['values']['textsize_normal'];
  $ts_di = $form_state['values']['textsize_display'];
  $ts_mi = $form_state['values']['textsize_minimum'];
  $ts_ma = $form_state['values']['textsize_maximum'];
  $ts_no_display = textsize_display($ts_no, 0);
  $ts_st = ($ts_no - (round((($ts_no - $ts_mi) / $ts_in), 0) * $ts_in));
  $ts_en = ($ts_no + (round((($ts_ma - $ts_no) / $ts_in), 0) * $ts_in));
  $textsize_allowed_values = array();
  for ($value = $ts_st; $value <= $ts_en; $value = $value + $ts_in ) {
    $textsize_allowed_values[] = $value;
  };
  if ($form_state['values']['textsize_element'] === "body" && $form_state['values']['textsize_element_class'] != "") {
    form_set_error('textsize_element_class', t('The element class have to be empty for the body element.'));
  }
  if ($form_state['values']['textsize_element'] != "body" && $form_state['values']['textsize_element_class'] != "") {
    if (empty($form_state['values']['textsize_element_class'])) {
      form_set_error('textsize_element_class', t('The !abbr_xhtml !abbr_id/element class can not be empty.', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)));
    }
    if ($form_state['values']['textsize_element_class']{0} != "." && $form_state['values']['textsize_element_class']{0} != "#") {
    form_set_error('textsize_element_class', t('The !abbr_xhtml element !abbr_id/class have to be start with a hash ("#") for a !abbr_id or a point (".") for a class.', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)));
    }
    elseif ($form_state['values']['textsize_element_class'] === "." || $form_state['values']['textsize_element_class'] === "#") {
    form_set_error('textsize_element_class', t('The !abbr_xhtml element !abbr_id/class can not have only a hash ("#") or a point (".").', array('!abbr_xhtml' =>  $abbr_xhtml, '!abbr_id' =>  $abbr_id)));
    }
  }
  // Text Size Increment
  if (!is_numeric($ts_in) || $ts_in != round($ts_in)) {
    form_set_error('textsize_increment', t('Please enter a integer in:') .' "'. t('Increases/decreases step') .'".');
  }
  // Text Size Normal
  if (!is_numeric($ts_no) || $ts_no != round($ts_no)) {
    form_set_error('textsize_normal', t('Please enter a integer in:') .' "'. t('Text Size Normal') .'".');
  }
  if (is_numeric($ts_no) && $ts_no == round($ts_no) && !in_array($_COOKIE['textsize'], $textsize_allowed_values)) {
    $_SESSION['textsize'] = $ts_no;
    setcookie("textsize", $ts_no, time()+31536000, "/", "");
    drupal_set_message(t('The text size have been saved as %ts_value% (100%).', array('%ts_value' => $ts_no)));
  }
  if ($ts_no > ($ts_ma - $ts_in)) {
    form_set_error('textsize_normal', t('The text size normal is bigger than the maximum normal size of: !ts_size%.', array('!ts_size' =>  ($ts_ma - $ts_in))));
  }
  if ($ts_no < ($ts_mi + $ts_in)) {
    form_set_error('textsize_normal', t('The text size normal is less than the minimum normal size of: !ts_size%.', array('!ts_size' =>  ($ts_mi + $ts_in))));
  }
  // Text Size Minimum
  if (!is_numeric($ts_mi) || $ts_mi != round($ts_mi)) {
    form_set_error('textsize_minimum', t('Please enter a integer in:') .' "'. t('Minimum Text Size') .'".');
  }
  if ($ts_mi >= $ts_no) {
    form_set_error('textsize_minimum', t('The minimum text size can not be the same or bigger value than the normal textsize.'));
  }
  // Text Size Maximum
  if (!is_numeric($ts_ma) || $ts_ma != round($ts_ma)) {
    form_set_error('textsize_maximum', t('Please enter a integer in:') .' "'. t('Maximum Text Size') .'".');
  }
  // Warning
  if ((!in_array("100", $textsize_allowed_values)) && $ts_di == 1) {
    drupal_set_message( t('This configuration generate not a normal text size of 100% in the source code.'), "warning");
  }
  if ((!in_array("100", $textsize_allowed_values)) && $ts_di == 0) {
    drupal_set_message( t('Warning: This configuration generate and display not a normal text size of 100%!'), "warning");
  }
}
