<?php
// $Id: textsize-image.tpl.php,v 1.1.2.4 2009/10/01 01:41:10 christianzwahlen Exp $

/**
 * @file
 * Image theme implementation for rendering a block.
 *
 * Available variables:
 * - $block_title: Block title: "Text Size" or "Zoom".
 * - $dest: The drupal function drupal_get_destination().
 * - $list_inline: Display the ul list "inline" or not.
 * - $link_type: Return "variable" for variable or fix.
 * - $display_links: Show or hide ("display_hidden") the text in the links.
 * - $increment: The increment step (default 10%).
 * - $normal: The textsize normal (default 100%).
 * - $display_current_textsize: Show or hide ("display_hidden") the text of the current textsize.
 * - $current_textsize_text: The current textsize text "Current Size" or "Current Zoom".
 * - $textsize: The current text size (default 100%).
 *
 * @see template_preprocess_textsize_image()
 */
?>
<ul class="textsize_<?php print $list_inline; ?>">
  <li class="ts_increase_<?php print check_plain($link_type); ?>"><?php print l('<img src="'. base_path() . drupal_get_path("module", "textsize") .'/images/increase_16.gif" alt="'. t('Increase') .'" class="rollover" />', 'textsize/increase', array('attributes' => array('title' => $block_title .': '. t('Increase') .' +'. $increment .'%', 'class' => 'ts_increase_'. $link_type ), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li class="ts_decrease_<?php print check_plain($link_type); ?>"><?php print l('<img src="'. base_path() . drupal_get_path("module", "textsize") .'/images/decrease_16.gif" alt="'. t('Decrease') .'" class="rollover" />', 'textsize/decrease', array('attributes' => array('title' => $block_title .': '. t('Decrease') .' -'. $increment .'%', 'class' => 'ts_decrease_'. $link_type ), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li class="ts_normal_<?php print check_plain($link_type); ?>"><?php print l('<img src="'. base_path() . drupal_get_path("module", "textsize") .'/images/normal_16.gif" alt="'. t('Normal') .'" class="rollover" />', 'textsize/normal', array('attributes' => array('title' => $block_title .': '. t('Normal') .' ='. $normal .'%', 'class' => 'ts_normal_'. $link_type), 'query' => $dest, 'html' => TRUE)); ?></li>
</ul>
<p class="<?php print $display_current_textsize; ?>"><?php print $current_textsize_text; ?>: <span id="textsize_current"><?php print $textsize; ?>%</span></p>