<?php
// $Id: textsize-text.tpl.php,v 1.1.2.5 2009/10/01 01:41:10 christianzwahlen Exp $

/**
 * @file
 * Default theme implementation for rendering a block.
 *
 * Available variables:
 * - $block_title: Block title: "Text Size" or "Zoom".
 * - $dest: The drupal function drupal_get_destination().
 * - $list_inline: Display the ul list "inline" or not.
 * - $link_type: Return "variable" for variable or fix.
 * - $display_links: Show or hide ("display_hidden") the text in the links.
 * - $increment: The increment step (default 10%).
 * - $normal: The textsize normal (default 100%).
 * - $display_current_textsize: Show or hide ("display_hidden") the text of the current textsize.
 * - $current_textsize_text: The current textsize text "Current Size" or "Current Zoom".
 * - $textsize: The current text size (default 100%).
 *
 * @see template_preprocess_textsize_text()
 */
?>
<ul class="textsize_<?php print $list_inline; ?>">
  <li class="ts_increase_<?php print check_plain($link_type); ?>"><?php print l('<span class="'. $display_links .'">'. t('Increase') .'</span>', 'textsize/increase', array('attributes' => array('title' => $block_title .': '. t('Increase') .' +'. $increment .'%', 'class' => 'ts_icon ts_increase_'. $link_type .' textsize_increase'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li class="ts_decrease_<?php print check_plain($link_type); ?>"><?php print l('<span class="'. $display_links .'">'. t('Decrease') .'</span>', 'textsize/decrease', array('attributes' => array('title' => $block_title .': '. t('Decrease') .' -'. $increment .'%', 'class' => 'ts_icon ts_decrease_'. $link_type .' textsize_decrease'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <li class="ts_normal_<?php print check_plain($link_type); ?>"><?php print l('<span class="'. $display_links .'">'. t('Normal') .'</span>', 'textsize/normal', array('attributes' => array('title' => $block_title .': '. t('Normal') .' ='. $normal .'%', 'class' => 'ts_icon ts_normal_'. $link_type .' textsize_normal'), 'query' => $dest, 'html' => TRUE)); ?></li>
</ul>
<p class="<?php print $display_current_textsize; ?>"><?php print $current_textsize_text; ?>: <span id="textsize_current"><?php print $textsize; ?>%</span></p>
